﻿--This is an inplace fix for LibQTip, the current Lib is not resizing the height of the tooltips. 
--I had to copy some of the lines of code to fix the problem. This fix will be removed when the Lib is updated
function Liquid_Wealth:FixCellSizes(tooltip)
  local columns = tooltip.columns
  local colspans = tooltip.colspans
  local lines = tooltip.lines

  local TOOLTIP_PADDING = 10
  local CELL_MARGIN_H = 6
  local CELL_MARGIN_V = 3

  -- resize columns to make room for the colspans
  local h_margin = tooltip.cell_margin_h or CELL_MARGIN_H
  while next(colspans) do
    local maxNeedCols = nil
    local maxNeedWidthPerCol = 0
    -- calculate the colspan with the highest additional width need per column
    for colRange, width in pairs(colspans) do
      local left, right = colRange:match("^(%d+)%-(%d+)$")
      left, right = tonumber(left), tonumber(right)
      for col = left, right - 1 do
        width = width - columns[col].width - h_margin
      end
      width = width - columns[right].width
      if width <= 0 then
        colspans[colRange] = nil
      else
        width = width / (right - left + 1)
        if width > maxNeedWidthPerCol then
          maxNeedCols = colRange
          maxNeedWidthPerCol = width
        end
      end
    end
    -- resize all columns for that colspan
    if maxNeedCols then
      local left, right = maxNeedCols:match("^(%d+)%-(%d+)$")
      for col = left, right do
        Liquid_Wealth:EnlargeColumn(tooltip, columns[col], columns[col].width + maxNeedWidthPerCol)
      end
      colspans[maxNeedCols] = nil
    end
  end
  --now that the cell width is set, recalculate the rows' height
  for _, line in ipairs(lines) do
    if #(line.cells) > 0 then
      local lineheight = 0
      for _, cell in pairs(line.cells) do
        if cell and cell.fontstring then
          lineheight = max(lineheight, cell.fontstring:GetStringHeight())
          self:Print("Trying to Fix the Tip")
        end
      end
      if lineheight > 0 then
        Liquid_Wealth:ResizeLine(tooltip, line, lineheight)
        self:Print("Trying to Fix the Tip")
      end
    end
  end
end

function Liquid_Wealth:EnlargeColumn(tooltip, column, width)
  if width > column.width then
    SetTooltipSize(tooltip, tooltip.width + width - column.width, tooltip.height)

    column.width = width
    column:SetWidth(width)
  end
end

function Liquid_Wealth:ResizeLine(tooltip, line, height)
  SetTooltipSize(tooltip, tooltip.width, tooltip.height + height - line.height)

  line.height = height
  line:SetHeight(height)
end

function SetTooltipSize(tooltip, width, height)
  local TOOLTIP_PADDING = 10
  tooltip:SetHeight(2 * TOOLTIP_PADDING + height)
  tooltip.scrollChild:SetHeight(height)
  tooltip.height = height

  tooltip:SetWidth(2 * TOOLTIP_PADDING + width)
  tooltip.scrollChild:SetWidth(width)
  tooltip.width = width
end