﻿function Liquid_Wealth:BuildIcons(Char, scale) --Builds the Players Icon Texture file path
  local Gender = { "N/A", "Male", "Female" };
  local texLocationClass = "Interface\\Addons\\Liquid_Wealth\\Images\\Class\\";
  local texLocationRaces = "Interface\\Addons\\Liquid_Wealth\\Images\\Race\\";
  local texExt = ".blp"
  local texLocationRace = "Interface\\Icons\\";
  local texString = "";
  local sex, race, class = strsplit(":", Char);
  if scale == nil then scale = 15 end
  --texString="|T"..texLocationRace..race.."-"..Gender[tonumber(sex)]..".tga:"..scale.."|t".."|T"..texLocationClass..class.."_icon.tga:"..scale.."|t";
  if (race == "Blood Elf") then
    texString = "|T" .. texLocationRace .. "Achievement_Character_Bloodelf_" .. Gender[tonumber(sex)] .. ":" .. scale .. "|t" .. "|T" .. texLocationClass .. class .. texExt .. ":" .. scale .. "|t";
  elseif (race == "Night Elf") then
    texString = "|T" .. texLocationRace .. "Achievement_Character_Nightelf_" .. Gender[tonumber(sex)] .. ":" .. scale .. "|t" .. "|T" .. texLocationClass .. class .. texExt .. ":" .. scale .. "|t";
  elseif (race == "Goblin") then -- There is no Achievement for this race so its not in the Achievement frame
    texString = "|T" .. texLocationRaces .. race .. "-" .. Gender[tonumber(sex)] .. texExt .. ":" .. scale .. "|t" .. "|T" .. texLocationClass .. class .. texExt .. ":" .. scale .. "|t";
  elseif (race == "Worgan") then -- There is no Achievement for this race so its not in the Achievement frame
    texString = "|T" .. texLocationRaces .. race .. "-" .. Gender[tonumber(sex)] .. texExt .. ":" .. scale .. "|t" .. "|T" .. texLocationClass .. class .. texExt .. ":" .. scale .. "|t";
  else
    texString = "|T" .. texLocationRace .. "Achievement_Character_" .. race .. "_" .. Gender[tonumber(sex)] .. ":" .. scale .. "|t" .. "|T" .. texLocationClass .. class .. texExt .. ":" .. scale .. "|t";
  end
  return texString;
end

function Liquid_Wealth:BuildBagIcons(itemID, ItemTexturePath, scale)
  if scale == nil then scale = 15 end
  if (itemID == "Bank") or (itemID == "Backpack") then --Show BagIcon for bank or backup
    return "|TInterface\\Icons\\INV_Misc_Bag_08:" .. scale .. "|t";
  elseif not (ItemTexturePath == nil) then
    return "|T" .. ItemTexturePath .. ":" .. scale .. "|t";
    --elseif (itemID=="NONE") or (itemID==nil) or (itemID=="") or (itemID==0) then
  else
    return "|TInterface\\GossipFrame\\ActiveQuestIcon:" .. scale .. "|t"; --Show QuestIcon if no bag is dected
  end
end

function Liquid_Wealth:ClassColor(Char)
  local fontcolor = "FFFFFF"
  local _, _, class = strsplit(":", Char)
  if (class == "Death Knight") then
    fontcolor = "C41F3B"
  elseif (class == "Druid") then
    fontcolor = "FF7D0A"
  elseif (class == "Hunter") then
    fontcolor = "ABD473"
  elseif (class == "Mage") then
    fontcolor = "69CCF0"
  elseif (class == "Paladin") then
    fontcolor = "F58CBA"
  elseif (class == "Priest") then
    fontcolor = "FFFFFF"
  elseif (class == "Rogue") then
    fontcolor = "FFF569"
  elseif (class == "Shaman") then
    fontcolor = "0070DE"
  elseif (class == "Warlock") then
    fontcolor = "9482C9"
  elseif (class == "Warrior") then
    fontcolor = "C79C6E"
  end
  return "FF" .. fontcolor
end
